/* tmnbbr.f -- translated by f2c (version 20000817).
   You must link the resulting object file with the libraries:
        -lf2c -lm   (in that order)
*/

#include "f2c.h"

int main(void)
{
    /* Initialized data */
    static float alfa = 1.f;
    static int nmp1 = 3;
    static int itmt = 200;
    static int maxt = 500;
    static float beta = .5f;
    static float gam = 2.f;
    static int n = 2;
    static int itmax = 50;
    static int maxk = 400;
    static float acc = 1e-6f;
    static float a = .3f;
    static float xx[2] = { 1.f,1.f };

    /* Local variables */
    static int ierr;
    extern int t_c();
    extern int mnbbr_c(int *, int *, int *, int *, float *, float *,
                       float *, float *, float *, float *, float *, float *,
                       float *, int *, int *, U_fp, U_fp, int *);
    extern int f0_c();
    static float ff, vec[16] /* was [2][8] */,
                     xyz[18] /* was [3][6] */;

    printf("\n %5i \n", n);
    printf("\n %10.4e \n", acc);
    printf("\n %5.2f %5.2f %5.2f \n", alfa, beta, gam);
    printf("\n %16.7e %16.7e \n", xx[0], xx[1]);
    mnbbr_c(&n, &nmp1, &itmax, &itmt, &alfa, &beta, &gam, &acc, &a, xyz, xx,
            vec, &ff, &maxk, &maxt, (U_fp)f0_c, (U_fp)t_c, &ierr);

    printf("\n\n %5i \n", maxt);
    printf("\n %5i \n", ierr);
    printf("\n %5i \n", itmax);
    printf("\n %5i \n", maxk);
    printf("\n %16.7e \n", ff);
    printf("\n %16.7e %16.7e \n", xx[0], xx[1]);
/* L1: */
    return 0;
} /* main */

int f0_c(float *x, float *f, float *fe)
{
    /* System generated locals */
    float r__1;

    /* Parameter adjustments */
    --x;

    /* Function Body */
/* Computing 2nd power */
    r__1 = x[2];
    *f = x[1] * 4.f - r__1 * r__1 - 12.f;
    return 0;
} /* f0_c */

int t_c(float *x, float *f, float *fe)
{
    /* System generated locals */
    float r__1, r__2;

    /* Builtin functions */
    double sqrt(double);

    /* Local variables */
    static float r__;

    /* Parameter adjustments */
    --x;

    /* Function Body */
/* Computing 2nd power */
    r__1 = x[1];
/* Computing 2nd power */
    r__2 = x[2];
    *f = 25.f - r__1 * r__1 - r__2 * r__2;
/* Computing 2nd power */
    r__1 = *f;
    *f = r__1 * r__1;
/* Computing 2nd power */
    r__1 = x[1] - 5.f;
/* Computing 2nd power */
    r__2 = x[2] - 5.f;
    r__ = r__1 * r__1 + r__2 * r__2 - 16.f;
    r__ = -r__;
    if (r__ < 0.f) {
/* Computing 2nd power */
        r__1 = r__;
        *f += r__1 * r__1;
    }
    if (x[1] < 0.f) {
/* Computing 2nd power */
        r__1 = x[1];
        *f += r__1 * r__1;
    }
    if (x[2] < 0.f) {
/* Computing 2nd power */
        r__1 = x[2];
        *f += r__1 * r__1;
    }
    *f = (float)sqrt(*f);
    return 0;
} /* t_c */
